<?php

/**
 * @file
 * Contains the Fetchgals administration functionality.
 */

/**
 * Displays the administration screen.
 */
function fetchgals_admin() {
  if (fetchgals_process(variable_get('fetchgals_pid', 0))) {
    $form['message'] = array(
      '#type' => 'item',
      '#description' => '<h2>'. l(t('A fetchgals process is currently running.'), 'admin/reports/fetchgals', array('attributes' => array('class' => 'fetchgals-message'))) .'</h2>',
    );
  }
  $form['clean'] = array(
    '#type' => 'fieldset',
    '#title' => t('Cleaning Operations:'),
    '#collapsible' => TRUE,
    '#collapsed' => TRUE,
  );
  $form['clean']['submit6'] = array(
    '#type' => 'submit',
    '#value' => t('Clean Galleries File'),
  );
  $form['clean']['submit7'] = array(
    '#type' => 'submit',
    '#value' => t('Clean Gals Downloaded File'),
  );
  $form['clean']['submit8'] = array(
    '#type' => 'submit',
    '#value' => t('Clean Gals Processed File'),
  );
  $form['clean']['item1'] = array(
    '#type' => 'item',
    '#description' => t(<<<EOT
<dl>
  <dt><strong><a name="item_%2e%2fgalleries"><em>%var1</em></a></strong></dt>
  <dd>This file is created by <strong>fetchgals</strong> and contains gallery URLs and
    corresponding preview thumbnail URLs and descriptive text, one gallery
    and one thumbnail and one text per line, separated by '|'. The purpose
    of the file is to record the galleries that have already been found,
    so that they are not processed again during a later invocation of
    <strong>fetchgals</strong>. The file's contents may also be useful for other
    programs. The default file name can be overridden with the
    <strong>-gallery_file</strong> option.
  </dd>
  <dt><strong><a name="item_%2e%2fgals_downloaded"><em>%var2</em></a></strong></dt>
  <dd>This file contains a list of those galleries whose pictures have been
    completely downloaded to the local computer. This allows to interrupt
    a download and resume later. Also, if <strong>fetchgals</strong> is run again and
    finds new galleries, only those not contained in this file will be
    downloaded by the <strong>-download_pics</strong> option. The default file name can
    be overridden with the <strong>-processed_downloads_file</strong> option.
  </dd>
  <dt><strong><a name="item_%2e%2fgals_processed_html"><em>%var3</em></a></strong></dt>
  <dd>This file contains a list of those galleries for which HTML pages have
    been created on the local computer. If <strong>fetchgals</strong> is run again and
    finds new galleries, only those not contained in this file will be
    processsed by the <strong>-create_html</strong> option. The default file name can be
    overridden with the <strong>-processed_html_file</strong> option.
  </dd>
</dl>        
EOT
      ,
      array('%var1' => variable_get('fetchgals_gallery_file', './galleries'),
            '%var2' => variable_get('fetchgals_processed_downloads_file', './gals_downloaded'),
            '%var3' => variable_get('fetchgals_processed_html_file', './gals_processed_html')
      )
    ),
  );
  $form['clean']['submit9'] = array(
    '#type' => 'submit',
    '#value' => t('Purge HTML Directory'),
  );
  $form['clean']['submit10'] = array(
    '#type' => 'submit',
    '#value' => t('Purge Pictures Directory'),
  );
  $form['clean']['item2'] = array(
    '#type' => 'item',
    '#description' => t(<<<EOT
<dl>
  <dt><strong><a name="item_%2dhtml_dir_dir"><em>%dir1</em></a></strong></dt>
  <dd>The directory where the <strong>-create_html</strong> action creates the HTML files.
    Defaults to <em>./porn_html</em>. The directory will be created if it doesn't exist.
    The file <em>index.html</em> in that directory links to the other created HTML files.
  </dd>
  <dt><strong><a name="item_%2dpics_dir_dir"><em>%dir2</em></a></strong></dt>
  <dd>The directory where the <strong>-download_pics</strong> action stores the downloaded images.
    Defaults to <em>./porn_pics</em>. The directory will be created if it doesn't exist.
    The pictures receive names indicating their origin and are stored in subdirectories a-z
    depending on the first letter of their name.
  </dd>
      </dl>
EOT
      ,
      array('%dir1' => variable_get('fetchgals_html_dir', './porn_html'),
            '%dir2' => variable_get('fetchgals_pics_dir', './porn_pics'))
    ),
  );
  $form['find_galleries'] = array(
    '#type' => 'fieldset',
  );
  $form['find_galleries']['submit1'] = array(
    '#type' => 'submit',
    '#value' => t('Find Galleries'),
  );
  $form['find_galleries']['item'] = array(
    '#type' => 'item',
    '#description' => t(<<<EOT
Reads a list of TGP URLs from the file specified with <strong>-tgp_file</strong>
(default: <em>./tgps</em>) and tries to locate all thumbnail galleries
that are linked from these TGPs. The URLs of these galleries, together with
URLs for preview thumbnails, are then written to the file specified
with <strong>-gallery_file</strong> (default: <em>./galleries</em>).
EOT
    ),
  );
  $form['download_pics'] = array(
    '#type' => 'fieldset',
    '#collapsible' => FALSE,
    '#collapsed' => FALSE,
  );
  $form['download_pics']['submit2'] = array(
    '#type' => 'submit',
    '#value' => t('Download Pictures'),
  );
  $form['download_pics']['item'] = array(
    '#type' => 'item',
    '#description' => t(<<<EOT
Reads a list of galleries from the file specified with
<strong>-gallery_file</strong> (default: <em>./galleries</em>) and downloads all the
pictures linked from those galleries. The pictures are stored in the
directory specifed with <strong>-pics_dir</strong> (default: <em>./porn_pics</em>).
<p>You need to run <strong>-find_galleries</strong> at least once before you can run
<strong>-download_pics</strong>.</p>
<p>The URLs of the galleries all of whose pictures have been completely
downloaded are recorded in the file specified with
<strong>-processed_downloads_file</strong> (default: <em>./gals_downloaded</em>). Because
of this, the program never downloads the same gallery twice, and it is
able to resume a download after it was interrupted.</p>
EOT
    ),
  );
  $form['create_html'] = array(
    '#type' => 'fieldset',
    '#collapsible' => FALSE,
    '#collapsed' => FALSE,
  );
  $form['create_html']['submit3'] = array(
    '#type' => 'submit',
    '#value' => t('Create HTML'),
  );
  $form['create_html']['item'] = array(
    '#type' => 'item',
    '#description' => t(<<<EOT
Reads a list of galleries and associated preview thumbnails from the
file specified with <strong>-gallery_file</strong> (default: <em>./galleries</em>) and
creates a set of HTML files that link to these galleries. The HTML
files are created in the directory specified with <strong>-html_dir</strong>
(default: <em>./porn_html</em>). Neither the thumbnails nor the galleries
are downloaded, so this actions is much faster than <strong>-download_pics</strong>
and uses up only very little local storage space.</p>
<p>You need to run <strong>-find_galleries</strong> at least once before you can run
<strong>-create_html</strong>.</p>
<p>The URLs of the galleries for which local HTML files have been created
are recorded in the file specified with <strong>-processed_html_file</strong>
(default: <em>./gals_processed_html</em>). This is so that the program only
produces HTML files for the most recently found galleries.</p>
EOT
    ),
  );
  $form['tgps'] = array(
    '#type' => 'fieldset',
    '#title' => t('TGPS File:'),
    '#collapsible' => TRUE,
    '#collapsed' => TRUE,
  );
  $form['tgps']['submit4'] = array(
    '#type' => 'submit',
    '#value' => t('Execute FindTGPS'),
  );
  $form['tgps']['fetchgals_tgps'] = array(
    '#type' => 'textarea',
    '#title' => "The main input file, containing TGP URLs, one per line. The ``http://'' is optional. Lines starting with # are ignored",
    '#default_value' => file_get_contents(fetchgals_check(variable_get('fetchgals_tgp_file', './tgps'))),
    '#cols' => 80,
    '#rows' => 150,
    '#attributes' => is_writeable(fetchgals_check(variable_get('fetchgals_tgp_file', './tgps'))) ? '' : array('disabled' => TRUE),
  );
  if (is_writeable(fetchgals_check(variable_get('fetchgals_tgp_file', './tgps')))) {
    $form['tgps']['submit5'] = array(
      '#type' => 'submit',
      '#value' => t('Edit TGPS'),
    );
  }
  return $form;
} // fetchgals_admin

/**
 * Submit function for fetchgals_admin form.
 */
function fetchgals_admin_submit($form, &$form_state) {
  switch ($form_state['clicked_button']['#post']['op']) {
    case t('Find Galleries'):
      fetchgals_find_galleries();
      break;
    case t('Download Pictures'):
      fetchgals_download_pics();
      break;
    case t('Create HTML'):
      fetchgals_create_html();
      break;
    case t('Execute FindTGPS'):
      fetchgals_findtgps();
      break;
    case t('Edit TGPS'):
      fetchgals_edit_tgps($form_state['values']['fetchgals_tgps']);
      break;
    case t('Clean Galleries File'):
      fetchgals_clean_file(variable_get('fetchgals_gallery_file', './galleries'));
      break;
    case t('Clean Gals Downloaded File'):
      fetchgals_clean_file(variable_get('fetchgals_processed_downloads_file', './gals_downloaded'));
      break;
    case t('Clean Gals Processed File'):
      fetchgals_clean_file(variable_get('fetchgals_processed_html_file', './gals_processed_html'));
      break;
    case t('Purge HTML Directory'):
      fetchgals_clean_dir(variable_get('fetchgals_html_dir', './porn_html'), FALSE);
      drupal_set_message(t('HTML Directory has been cleaned.'));
      break;
    case t('Purge Pictures Directory'):
      fetchgals_clean_dir(variable_get('fetchgals_pics_dir', './porn_pics'), FALSE);
      drupal_set_message(t('Pictures Directory has been cleaned.'));
      break;
  }
} // fetchgals_admin_submit

/**
 * Creates and submits the find_galleries function.
 */
function fetchgals_find_galleries() {
  if (!_fetchgals_initial_checks(FETCHGALS_PREPROCESS)) {
    return;
  }
  _fetchgals_clear_log();
  $args[] = '-find_galleries';
  $args[] = '-tgp_file '. fetchgals_check(variable_get('fetchgals_tgp_file', './tgps'));
  if (variable_get('fetchgals_extensive_search', 0)) {
    $args[] = '-extensive_search';
    $args[] = '-attempts_per_link '. variable_get('fetchgals_attempts_per_link', 5);
    $args[] = '-sleep_time '. variable_get('fetchgals_sleep_time', 7);
  }
  $args[] = '-gallery_file '. fetchgals_check(variable_get('fetchgals_gallery_file', './galleries'));
  if (variable_get('fetchgals_use_cookies', 0)) {
    $args[] = '-use_cookies';
  }
  _fetchgals_execute(t('Find Galleries'), $args);
} // fetchgals_find_galleries

/**
 * Creates and submits the download_pics function.
 */
function fetchgals_download_pics() {
  if (!_fetchgals_initial_checks(FETCHGALS_PROCESSED)) {
    return;
  }
  _fetchgals_clear_log();
  $args[] = '-download_pics';
  $args[] = '-gallery_file '. fetchgals_check(variable_get('fetchgals_gallery_file', './galleries'));
  $args[] = '-pics_dir '. fetchgals_check(variable_get('fetchgals_pics_dir', './porn_pics'));
  $args[] = '-processed_downloads_file '. fetchgals_check(variable_get('fetchgals_processed_downloads_file', './gals_downloaded'));
  $args[] = '-types "'. variable_get('fetchgals_types', 'jpg|jpeg|gif|png|mpg|mpeg|avi|asf|mov|wmv') .'"';
  $args[] = '-min_img_size '. variable_get('fetchgals_min_img_size', 15000);
  $args[] = '-max_img_size '. variable_get('fetchgals_max_img_size', 250000);
  $args[] = '-max_disk_usage '. variable_get('fetchgals_max_disk_usage', 95);
  $args[] = '-pic_file_template '. variable_get('fetchgals_pic_file_template', '%i/%h-%p-%n%e');
  $args[] = '-num_download_processes '. variable_get('fetchgals_num_download_processes', 8);
  $args[] = '-processed_html_file '. fetchgals_check(variable_get('fetchgals_processed_html_file', './gals_processed_html'));
  _fetchgals_execute(t('Download Pictures'), $args);
} // fetchgals_download_pics

/**
 * Creates and submits the create_html function.
 */
function fetchgals_create_html() {
  if (!_fetchgals_initial_checks(FETCHGALS_PROCESSED)) {
    return;
  }
  _fetchgals_clear_log();
  $args[] = '-create_html';
  $args[] = '-gallery_file '. fetchgals_check(variable_get('fetchgals_gallery_file', './galleries'));
  $args[] = '-html_dir '. fetchgals_check(variable_get('fetchgals_html_dir', './porn_html'));
  $args[] = '-thumbs_per_row '. variable_get('fetchgals_thumbs_per_row', 6);
  $args[] = '-rows_per_file '. variable_get('fetchgals_rows_per_file', 10);
  $args[] = '-processed_html_file '. fetchgals_check(variable_get('fetchgals_processed_html_file', './gals_processed_html'));
  _fetchgals_execute(t('Create HTML'), $args);
} // fetchgals_create_html

/**
 * Executes the findtgps program.
 */
function fetchgals_findtgps() {
  if (!_fetchgals_initial_checks(FETCHGALS_PREPROCESS)) {
    return;
  }
  _fetchgals_clear_log();
  $args[] = '-in '. fetchgals_check(variable_get('findtgps_in', './tgps'));
  $args[] = '-out '. fetchgals_check(variable_get('findtgps_out', './tgps'));
  $args[] = '-known_tgps '. fetchgals_check(variable_get('findtgps_known_tgps', './tgps'));
  $args[] = '-link_threshold '. variable_get('findtgps_link_threshold', 30);
  $args[] = '-fraction_followed '. variable_get('findtgps_fraction_followed', 6);
  $args[] = '-threads '. variable_get('findtgps_threads', 8);
  _fetchgals_execute(t('Find TGPS'), $args);
} // fetchgals_findtgps

/**
 * Function to manually edit TGPS file.
 */
function fetchgals_edit_tgps($edit) {
  if (file_put_contents(fetchgals_check(variable_get('fetchgals_tgp_file', './tgps')), $edit)) {
    drupal_set_message(t('TGPS file successfully updated.'));
  }
  else {
    drupal_set_message(t('TGPS file update FAILED.'), 'error');
  }
} // fetchgals_edit_tgps

/**
 * Empties the specified file.
 */
function fetchgals_clean_file($file) {
  file_put_contents(fetchgals_check($file), '');
  drupal_set_message(t('%file cleaned.', array('%file' => $file)));
} // fetchgals_clean_file