<?php

/**
 * @file
 * The Fetchgals page viewer functionality.
 */

/**
 * View the created pages.
 */
function fetchgals_view($page) {
  // Step #1:
  // Get the file.
  $output = @file_get_contents(fetchgals_check(variable_get('fetchgals_html_dir', './porn_html')) ."/$page");
  // If it doesn't exist then throw an error.
  if (!$output) {
    drupal_set_message(t('Fetchgals HTML files do not exist.'), 'error');
    watchdog('fetchgals', 'Fetchgals HTML files do not exist.', array(), WATCHDOG_ERROR);
    return FALSE;
  }

  // Step #2:
  // Tidy up output, we're only interested in what is between the body tags;
  if (preg_match("/<body>(.*?)<\/body>/s", $output, $match)) {
    $output = $match[1];
  }
  else {
    return drupal_access_denied();
  }
  // Step #3:
  // Get the page title from between the h1 tags;
  preg_match("/<h1>(.*?)<\/h1>/i", $output, $title);
  // Step #4:
  // Rewrite all the internal navigation links so the module picks them up, note the front index page is slightly different.
  if ($page == 'index.html') {
    $output = preg_replace("/<a href=\"/", '<a href="'. url("fetchgals/"), $output);
    preg_match_all("/<h2>(.*?)<\/h2>/i", $output, $heading);
    preg_match_all("/<ul[^>]*>(.*?)<\/ul>/s", $output, $lists);
    foreach ($lists[1] as $key => $list) {
      preg_match_all("/<li[^>]*>(.*?)\n/", $list, $items);
      $build[] = array(
        'heading' => $heading[1][$key],
        'list' => $items[1],
      );
    }
    return theme('fetchgals_view_index', $title[1], $build);
  }
  $list = array();
  $output = preg_replace_callback("/<center>(.*?)<\/center>/i", create_function('$text', "return '<center>'. str_replace('<a href=\"', '<a href=\"'. url('fetchgals/'), \$text[1]) .'</center>';"), $output);
  preg_match("/<center>(.*?)<\/center>/i", $output, $heading);
  preg_match_all("/<tr[^>]*>(.*?)<\/tr>/si", $output, $rows);
  foreach ($rows[1] as $row) {
    preg_match_all("/<td[^>]*>(.*?)\n/", $row, $items);
    $list[] = $items[1];
  }
  return theme('fetchgals_view_page', $title[1], $heading[1], $list);
} // fetchgals_view